commit 17eae3d3bfbacd7ac47297b560a2a65a51e94a60
Author: Pengfei Li <Pengfei.Li2@arm.com>
Date:   Thu Aug 7 16:52:45 2025

    AArch64: Fix invalid immediate offsets in SVE gather/scatter [PR121449]
    
    This patch fixes incorrect constraints in RTL patterns for AArch64 SVE
    gather/scatter with type widening/narrowing and vector-plus-immediate
    addressing. The bug leads to below "immediate offset out of range"
    errors during assembly, eventually causing compilation failures.
    
    /tmp/ccsVqBp1.s: Assembler messages:
    /tmp/ccsVqBp1.s:54: Error: immediate offset out of range 0 to 31 at operand 3 -- `ld1b z1.d,p0/z,[z1.d,#64]'
    
    Current RTL patterns for such instructions incorrectly use vgw or vgd
    constraints for the immediate operand, base on the vector element type
    in Z registers (zN.s or zN.d). However, for gather/scatter with type
    conversions, the immediate range for vector-plus-immediate addressing is
    determined by the element type in memory, which differs from that in
    vector registers. Using the wrong constraint can produce out-of-range
    offset values that cannot be encoded in the instruction.
    
    This patch corrects the constraints used in these patterns. A test case
    that reproduces the issue is also included.
    
    Bootstrapped and regression-tested on aarch64-linux-gnu.
    
    gcc/ChangeLog:
            PR target/121449
            * config/aarch64/aarch64-sve.md
            (mask_gather_load<mode><v_int_container>): Use vg<Vesize>
            constraints for alternatives with immediate offset.
            (mask_scatter_store<mode><v_int_container>): Likewise.
    
    gcc/testsuite/ChangeLog:
            PR target/121449
            * g++.target/aarch64/sve/pr121449.C: New test.

diff --git a/gcc/testsuite/g++.target/aarch64/sve/pr121449.C b/gcc/testsuite/g++.target/aarch64/sve/pr121449.C
new file mode 100644
index 00000000000..b2e13765dfa
--- /dev/null
+++ b/gcc/testsuite/g++.target/aarch64/sve/pr121449.C
@@ -0,0 +1,44 @@
+/* PR target/121449 */
+/* { dg-do assemble { target aarch64_asm_sve_ok } } */
+/* { dg-options "-O3 -save-temps" } */
+
+struct example;
+
+struct array {
+  unsigned length();
+  example *operator[](unsigned i) {
+    example **data = reinterpret_cast<example **>(this);
+    return data[i];
+  }
+};
+
+struct example {
+  int a[16];
+  bool is_even;
+  int version;
+  int count() { return is_even ? 2 : 1; }
+  void fun1(int, long);
+  void fun2(unsigned, unsigned);
+  void process(array &, array &);
+};
+
+bool found;
+
+void example::process(array &a, array &b) {
+  for (unsigned i = 1; a.length(); i++) {
+    long total = 0;
+    for (unsigned k = 0; k <= i; k++) {
+      total += a[k]->count();
+    }
+    for (unsigned j = 0; j < i; j++) {
+      int major = b[j]->version;
+      if (found)
+        major += i;
+      fun1(i + 1, total);
+      fun2(j, major);
+    }
+  }
+}
+
+/* { dg-final { scan-assembler-not {\tld1b\t(z[0-9]+)\.d, p[0-7]/z, \[(z[0-9]+)\.d, #64\]} } } */
+

